//: c13:ResponsiveUI.java
// Wraliwo interfejsu uytkownika.
// Z ksiki 'Thinking in Java, 3rd ed.' (c) Bruce Eckel 2002
// www.BruceEckel.com. Patrz uwagi w pliku CopyRight.txt.
import com.bruceeckel.simpletest.*;

class UnresponsiveUI {
  private volatile double d = 1;
  public UnresponsiveUI() throws Exception {
    while(d > 0)
      d = d + (Math.PI + Math.E) / d;
    System.in.read(); // Wykonywanie nigdy tu nie dochodzi
  }
}

public class ResponsiveUI extends Thread {
  private static Test monitor = new Test();
  private static volatile double d = 1;
  public ResponsiveUI() {
    setDaemon(true);
    start();
  }
  public void run() {
    while(true) {
      d = d + (Math.PI + Math.E) / d;
    }
  }
  public static void main(String[] args) throws Exception {
    //! new UnresponsiveUI(); // Trzeba "zabi" ten proces
    new ResponsiveUI();
    Thread.sleep(300);
    System.in.read(); // 'monitor' zapewnia wejcie
    System.out.println(d); // prezentacja postpw
  }
} ///:~
